import java.util.Random;
import processing.core.PApplet;

int gameState = 0;

int knopfX = 860;
int knopfY = 600;
int knopfBreite = 200;
int knopfHoehe = 80;

PImage hintergrundbild;    //Himmel Hintergrund Startseite
PFont knopfFont;           //Knopf Spiel spielen
PImage anleitung;          //Anleitung
PImage backgroundImagep;   //Himmel Hintergrund Spiel
PImage centerImage;        //Spielfigur

int score = 0;             // Punktzahl

int x = 850;               //x-Koordinate der Spielfigur
int y = 500;               //y-Koordinate der Spielfigur
int vy = -15;              // Geschwindigkeit der Spielfigur
int bgY = 1100;            //y-koordinate des Hintergrundbilds


int obstacleX = 500;       // x-Koordinate des Hindernisses
int obstacleY = 0;         // y-Koordinate des Hindernisses
int obstacleSize = 100;    // Größe des Hindernisses

int obstacleType = 1; // Aktuelle Hinderniss-Art

int cooldown = 0;

Random rand = new Random();// Zufallsgenerator für Hindernisse

ArrayList<Obstacle> obstacles = new ArrayList<>();


/////////Kollision mit einem Objekt
boolean collision(int x1, int y1, int w1, int h1, int x2, int y2, int w2, int h2) {
  if (x1 + w1 > x2 && x1 < x2 + w2 && y1 + h1 > y2 && y1 < y2 + h2) {
    return true;
  } else {
    return false;
  }
}


void setup() {
  fullScreen ();

  hintergrundbild = loadImage("startseite.jpg");
  knopfFont = createFont("Arial", 32);
  anleitung = loadImage("anleitung.png");
  backgroundImagep = loadImage("backgroundImagep.png");
  backgroundImagep.resize(width, height);
  centerImage = loadImage("spielfigur.tiff");
  centerImage.resize (250/2, 200/2);//neue Breite und Höhe des Bildes
}

void draw() {
  switch(gameState) {
    ////////////Startseite
  case 0:
    background(255);
    image(hintergrundbild, 0, 0, width, height);//Hintergrundbild
    fill(0);
    textAlign(CENTER, CENTER);
    textSize(75);
    text("Bouncy Bird", width/2, height/2 - 100);//Titeltext
    fill(0);
    noStroke();
    strokeWeight(5);
    rect(knopfX, knopfY, knopfBreite, knopfHoehe);
    fill(255);
    textSize(32);
    textFont(knopfFont);
    textAlign(500, 500);
    text("Spiel spielen", knopfX+10, knopfY+50);//Knopf
    fill(0);
    textSize(24);
    circle (width - 50, 50, 50);//Kreis um i
    fill(255);
    textAlign(width - 50, 50);
    text("i", width-52, 60);
    break;

    /////////////Anleitung Case
  case 1:
    background(255);
    image(anleitung, 0, 0, width, height);
    // Umkreistes "x" zeichnen
    fill(0);
    stroke(255);
    strokeWeight(4);
    ellipse(width - 50, 50, 50, 50);
    line(width - 70, 30, width - 30, 70);
    line(width - 70, 70, width - 30, 30);
    break;

    //////////////Spiel Startseite Case
  case 2:
    background(255);
    image(backgroundImagep, 0, 0, width, bgY); // Hintergrundbild Spiel
    //imageMode(CENTER);
    image(centerImage, x, y);
    textAlign(CENTER, CENTER);
    textSize(48);
    fill(0);
    text("Drücke Leerzeichen Zum Starten!", width/2, height/1.75 + 150);
    break;

    ////////////////////////////////////Spiel wird gestartet
  case 3:

    image(backgroundImagep, 0, bgY);// Hintergrundbild Spiel
    image(backgroundImagep, 0, bgY-height);
    image(backgroundImagep, 0, bgY+height);
    image(centerImage, x, y);

    if (obstacles.size() == 0) {
      // Spielbeginn
      obstacles.add(new Obstacle(obstacleX, obstacleY, obstacleSize, obstacleSize/2, 0, width, 10, 1));
      obstacleType=1;
    }

    // Schwerkraft & Sprungkraft
    y += vy;
    vy += 1;

    // Hintergrund bewegt sich wieder zurück an Ursprungsort wenn er aus dem Fenster geht
    if (bgY > height) {
      bgY -= height;
    }

    if (cooldown+10 > frameCount) { // Während der Spieler hochgeht / Springcooldown noch aktiv ist
      bgY+=15; // Hintergrund bewegt sich

      for (int i = 0; i < obstacles.size(); i++) { // For Schleife durch Obstacles
      
        Obstacle obstacle = obstacles.get(i);
        
        obstacle.oY+=15; // Obstacle geht runter

        if (obstacle.oY > height) obstacles.remove(obstacle); // Falls das Obstacle den Bildschirm verlässt wird es gelöscht

        if (obstacle.oY > y && obstacle.type == obstacleType) { // Falls das Obstacle, was auch wirklich das dem aktuellen Obstacletyp entspricht, unter dem Spieler ist, wird ein neues Obstacle kreiert.
          spawnNewObstacle();
          break;
        }
      }
    }
  

    if (keyPressed && key == ' ' && (cooldown+10<frameCount) && y > height/2-100) { // Spieler springt bei Leertaste wenn er Springen kann
      cooldown=frameCount;
      vy=-15;
    }

    // Falls der Spieler aus dem Fenster fällt wird er wieder hochgedrückt
    if (y > 850 && !keyPressed) {
      y=850;
      vy=-15;
    }

    for (int i = 0; i < obstacles.size(); i++) {
      Obstacle o = obstacles.get(i);
      // ForEach Schleife die durch die Obstacle liste geht
      rectMode(CORNER);
      rect(o.oX, o.oY, o.we, o.he);//Hindernis anzeigen

      // Bewegen von Rechts nach Links
      if (o.direction == RIGHT) {
        o.oX+=o.speed;
      } else o.oX-=o.speed;

      if (o.oX < o.minX) o.direction=RIGHT; // Falls der Obsactle den Linken Punkt erreicht hat, geht er nun nach rechts
      if (o.oX > o.maxX) o.direction=LEFT;  // Falls Rechter Punkt dann links

      o.berührt(); // auf Berührungen überprüfen
    }

    // Score anzeigen
    textAlign(LEFT, CENTER);
    textSize(32);
    fill(0);
    text("Score: " + score, 20, 50);
    break;
    /////////////////////////////GameOver
  case 4:
    // Display GameOver screen
    background(255);
    image(backgroundImagep, 0, 0, width, bgY); // Hintergrundbild Spiel
    image(centerImage, x, y);
    fill(0);
    textAlign(CENTER, CENTER);
    textSize(75);
    text("Bouncy Bird", width/2, height/2 - 125);//Titeltext
    // Linkes Kästchen zum Neustart des Spiels
    rect(100, height/2, 200, 100);
    textAlign(CENTER, CENTER);
    textSize(32);
    fill(255);
    text("Neustart", 200, height/2 + 50);
    fill(0);

    // Rechtes Kästchen zum Beenden des Spiels
    rect(width - 300, height/2, 200, 100);
    textAlign(CENTER, CENTER);
    textSize(32);
    fill(255);
    text("Beenden", width - 200, height/2 + 50);
    fill(0);
    // Score anzeigen
    textAlign(LEFT, CENTER);
    textSize(32);
    fill(0);
    text("Score: " + score, 20, 50);
    break;
  }
}

void mousePressed() {
  switch(gameState) {
    /////////////Zum Spiel durch Mausklick
  case 0:
    if (mouseX > knopfX && mouseX < knopfX+ knopfBreite && mouseY > knopfY && mouseY < knopfY + knopfHoehe) {
      gameState = 2; //Erhöhe den State
    }

    ////////////Zur Anleitung durch Mausklick
    if (sqrt((width-50-mouseX)*(width-50-mouseX) + (50-mouseY)*(50-mouseY)) <= 2*50) {
      gameState = 1;
    }

    break;
    ////////Zurück zur Startseite durch Mausklick
  case 1:
    if (sqrt((width - 50 - mouseX)*(width - 50 - mouseX) + (50 - mouseY)*(50 - mouseY)) <= 50) {
      // Mausklick innerhalb des umkreisten "x"
      gameState = 0;
    }
    break;
  case 2: // Spielbildschirm
    if (mouseButton == LEFT && mouseX >= obstacleX && mouseX <= obstacleX + obstacleSize
      && mouseY >= obstacleY && mouseY <= obstacleY + obstacleSize/2) {
      obstacleX = width + obstacleSize; // Hindernis zurücksetzen
      obstacleY = rand.nextInt(height - obstacleSize/2); // neue y-Koordinate für Hindernis generieren
    }
    break;
  case 4: // Game Over
    if (mouseButton == LEFT && mouseX >= 100 && mouseX <= 300 && mouseY >= height/2 && mouseY <= height/2 + 100) {
      gameState = 2; // Neustart des Spiels
      score = 0; // Score zurücksetzen
      y = 400; // y-Koordinate des beweglichen Bilds zurücksetzen
      vy = -15; // Geschwindigkeit des beweglichen Bilds zurücksetzen
      bgY = 0; // y-Koordinate des Hintergrundbilds zurücksetzen
      obstacleX = 500; // x-Koordinate des Hindernisses zurücksetzen
      obstacleY = 0; // y-Koordinate des Hindernisses zurücksetzen
    }
    if (mouseButton == LEFT && mouseX >= width - 300 && mouseX <= width - 100 && mouseY >= height/2 && mouseY <= height/2 + 100) {
      gameState = 0; // Spiel beenden
    }
    
    break;
  }
}
//////////Durch Leertaste das Spiel starten
void keyPressed() {
  if (keyCode == 32 && gameState == 2) {
    gameState = 3;
  }
}

///////// Obstacle - Code mit unserer Unterstützung

class Obstacle {
  int oX; // x-koordinate
  int oY; // y-koordinate
  int we; // breite
  int he; // höhe
  int minX; // Linker Punkt wohin sich das Obstacle bewegt
  int maxX; // Rechter Punkt wohin sich das Obstacle bewegt
  int speed; // Wie schnell das Obstacle ist
  int direction;
  int type;

  Obstacle(int x, int y, int we, int he, int minX, int maxX, int speed, int type) {
    this.oX=x;
    this.oY=y;
    this.we=we;
    this.he=he;
    this.minX = minX;
    this.maxX = maxX;
    this.speed = speed;
    this.type=type;

    direction = LEFT;
  }

  // Funktion die den Game Over detected / Berührungen bemerkt
  void berührt() {
    for (int a = this.oX; a < this.oX+this.we; a++) {
      for (int b = this.oY; b < this.oY+this.he; b++) {
        if (a > x && a < x+centerImage.width && b > y && b < y+centerImage.height) {
          obstacles.clear();
          gameState=4;
        }
      }
    }
  }
}

void spawnNewObstacle() {
  score+=1;
  
  int speed = Math.round(random(1,10)); // Objektgeschwindigkeit
  int newType = Math.round(random(1, 4)); // Neuer Objekttyp
  
  do {
    newType = Math.round(random(1, 4));
  } while (newType == obstacleType);
  obstacleType=newType;
  // Ein neuer Objekttyp wird hier oben bestimmt, mit do while 
  
  switch(newType) { // Je nach Objekttyp der zufällig generiert wurde, werden/wird ein neues Objekt in die Liste hinzugefügt & der Score geht um 1 höher
  case 1:
    obstacles.add(new Obstacle(0, -400, 200, 100, 0, width/3, speed, newType));
    obstacles.add(new Obstacle(width/3, -400, 200, 100, width/3, width/3*2,  speed, newType));
    obstacles.add(new Obstacle(width/3*2, -400, 200, 100, width/3*2, width/3*3, speed, newType));
    break;
  case 2:
    for (int i = 1; i < 6; i++) obstacles.add(new Obstacle(width/6*i, -400, 25, 50, width/6*i-200, width/6*i+200, speed, newType));
    break;
  case 3:
    int mitte = width/2;
    obstacles.add(new Obstacle(0, -400, 200, 50, 0, mitte, speed, newType));
    obstacles.add(new Obstacle(mitte, -400, 200, 50, mitte, mitte+200, speed, newType));
    break; 
  case 4:
    obstacles.add(new Obstacle(0, -400, 50, 100, 0, width, 20, newType));
    break;
  }
}
